diff --git a/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.module b/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.module
new file mode 100644
index 00000000..aba72f86
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.module
@@ -0,0 +1,198 @@
+<?php
+
+/**
+ * @file
+ * Primarily Drupal hooks.
+ */
+
+/**
+ * Implements hook_menu().
+ */
+function media_bulk_upload_menu() {
+  $items['admin/content/file/import'] = array(
+    'title' => 'Import files',
+    'description' => 'Import files into your media library.',
+    'page callback' => 'drupal_get_form',
+    'page arguments' => array('media_bulk_upload_import'),
+    'access arguments' => array('import media'),
+    'type' => MENU_LOCAL_ACTION,
+    'file' => 'includes/media_bulk_upload.admin.inc',
+    'weight' => 10,
+  );
+  $items['admin/content/file/thumbnails/import'] = $items['admin/content/file/import'];
+
+  // @todo Investigate passing file IDs in query string rather than a menu
+  // argument and then deprecate media_multi_load().
+  $items['admin/content/file/edit-multiple/%media_bulk_upload_multi'] = array(
+    'title' => 'Edit multiple files',
+    'page callback' => 'media_bulk_upload_file_page_edit_multiple',
+    'page arguments' => array(4),
+    'access callback' =>  '_media_bulk_upload_file_entity_access_recursive',
+    'access arguments' => array(4, 'update'),
+    'file' => 'includes/media_bulk_upload.pages.inc',
+  );
+
+  return $items;
+}
+
+/**
+ * Implements hook_permission().
+ */
+function media_bulk_upload_permission() {
+  return array(
+    'import media' => array(
+      'title' => t('Import media files from the local filesystem'),
+      'description' => t('Simple file importer'),
+      'restrict access' => TRUE,
+    ),
+  );
+}
+
+/**
+ * Implements hook_media_browser_plugin_info_alter().
+ */
+function media_bulk_upload_media_browser_plugin_info_alter(&$info) {
+  $info['upload']['class'] = 'MediaBrowserBulkUpload';
+}
+
+/**
+ * Implements hook_file_operations().
+ */
+function media_bulk_upload_file_operations() {
+  return array(
+    'edit_multiple' => array(
+      'label' => t('Edit selected files'),
+      'callback' => 'media_bulk_upload_file_operation_edit_multiple',
+    ),
+  );
+}
+
+/**
+ * Implements hook_form_alter().
+ */
+function media_bulk_upload_form_alter(&$form, &$form_state, $form_id) {
+  // If we're in the media browser, set the #media_browser key to true
+  // so that if an ajax request gets sent to a different path, the form
+  // still uses the media_browser_form_submit callback.
+  if (current_path() == 'media/browser' && $form_id != 'views_exposed_form') {
+    $form_state['#media_browser'] = TRUE;
+  }
+
+  // If the #media_browser key isset and is true we are using the browser
+  // popup, so add the media_browser submit handler.
+  if (!empty($form_state['#media_browser'])) {
+    $form['#submit'][] = 'media_bulk_upload_browser_form_submit';
+  }
+}
+
+/**
+ * Submit handler; direction form submissions in the media browser.
+ */
+function media_bulk_upload_browser_form_submit($form, &$form_state) {
+  $url = NULL;
+  $parameters = array();
+
+  // Multi upload.
+  if (!empty($form_state['files'])) {
+    $files = $form_state['files'];
+    $url = 'media/browser';
+    $parameters = array('query' => array('render' => 'media-popup', 'fid' => array_keys($files)));
+  }
+
+  // If $url is set, we had some sort of upload, so redirect the form.
+  if (!empty($url)) {
+    $form_state['redirect'] = array($url, $parameters);
+  }
+}
+
+/**
+ * Return a URL for editing an files.
+ *
+ * Works with an array of fids or a single fid.
+ *
+ * @param mixed $fids
+ *   An array of file IDs or a single file ID.
+ */
+function media_bulk_upload_file_edit_url($fids) {
+  if (!is_array($fids)) {
+    $fids = array($fids);
+  }
+
+  if (count($fids) > 1) {
+    return 'admin/content/file/edit-multiple/' . implode(' ', $fids);
+  }
+  else {
+    return 'file/' . reset($fids) . '/edit';
+  }
+}
+
+/**
+ * Callback for the edit operation.
+ *
+ * Redirects the user to the edit multiple files page.
+ *
+ * @param array $fids
+ *   An array of file IDs.
+ *
+ * @see media_file_page_edit_multiple()
+ */
+function media_bulk_upload_file_operation_edit_multiple($fids) {
+  // The thumbnail browser returns TRUE/FALSE for each item, so use array keys.
+  $fids = array_keys(array_filter($fids));
+  drupal_goto(media_bulk_upload_file_edit_url($fids), array('query' => drupal_get_destination()));
+}
+
+/**
+ * Implements hook_forms().
+ */
+function media_bulk_upload_forms($form_id, $args) {
+  $forms = array();
+  // To support the multiedit form, each form has to have a unique ID.
+  // So we name all the forms media_edit_N where the first requested form is
+  // media_edit_0, 2nd is media_edit_1, etc.
+  module_load_include('inc', 'file_entity', 'file_entity.pages');
+  if ($form_id != 'media_edit' && (strpos($form_id, 'media_edit') === 0)) {
+    $forms[$form_id] = array(
+      'callback' => 'file_entity_edit',
+    );
+  }
+  return $forms;
+}
+
+/**
+ * Access callback for the media-multi form.
+ *
+ * @param $files
+ *   An array of files being editing on the multiform.
+ * @param $op
+ *   A string containing the operation requested, such as 'update'.
+ * @return
+ *   TRUE if the current user has access to edit all of the files, otherwise FALSE.
+ */
+function _media_bulk_upload_file_entity_access_recursive($files, $op) {
+  // Check that the current user can access each file.
+  if (!empty($files)) {
+    foreach ($files as $file) {
+      if (!file_entity_access($op, $file)) {
+        return FALSE;
+      }
+    }
+    return TRUE;
+  }
+  return FALSE;
+}
+
+/**
+ * Load callback for %media_multi placeholder in menu paths.
+ *
+ * @param string $fids
+ *   Separated by space (e.g., "3 6 12 99"). This often appears as "+" within
+ *   URLs (e.g., "3+6+12+99"), but Drupal automatically decodes paths when
+ *   intializing $_GET['q'].
+ *
+ * @return array
+ *   An array of corresponding file entities.
+ */
+function media_bulk_upload_multi_load($fids) {
+  return file_load_multiple(explode(' ', $fids));
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaBrowserInternet.inc b/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaBrowserInternet.inc
index 919108f1..b719dc9a 100644
--- a/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaBrowserInternet.inc
+++ b/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaBrowserInternet.inc
@@ -20,8 +20,13 @@ class MediaBrowserInternet extends MediaBrowserPlugin {
    * Implements MediaBrowserPlugin::view().
    */
   public function view() {
-    module_load_include('inc', 'media_internet', 'media_internet.pages');
-    $build['form'] = drupal_get_form('media_internet_add', $this->params['types'], $this->params['multiselect']);
+    module_load_include('inc', 'file_entity', 'file_entity.pages');
+
+    $build = array();
+    $params = $this->params;
+    $params['internet_media'] = TRUE;
+    $build['form'] = drupal_get_form('media_internet_add_upload', $params);
+
     return $build;
   }
 }
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaInternetBaseHandler.inc b/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaInternetBaseHandler.inc
new file mode 100644
index 00000000..abd71d51
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaInternetBaseHandler.inc
@@ -0,0 +1,77 @@
+<?php
+
+/**
+ * @file
+ * Definition of MediaInternetBaseHandler.
+ */
+
+/**
+ * A base class for managing the addition of Internet media.
+ *
+ * Classes extending this class manage the addition of Internet media. To
+ * achieve this, the class should parse user-submitted embed code, claim it
+ * when appropriate and save it as a managed file.
+ */
+abstract class MediaInternetBaseHandler {
+
+  /**
+   * The constructor for the MediaInternetBaseHandler class. This method is also called
+   * from the classes that extend this class and override this method.
+   */
+  public function __construct($embedCode) {
+    $this->embedCode = $embedCode;
+  }
+
+  /**
+   * Determines if this handler should claim the item.
+   *
+   * @param string $embed_code
+   *   A string of user-submitted embed code.
+   *
+   * @return boolean
+   *   Pass TRUE to claim the item.
+   */
+  abstract public function claim($embed_code);
+
+  /**
+   * Returns a file object which can be used for validation.
+   *
+   * @return StdClass
+   */
+  abstract public function getFileObject();
+
+  /**
+   * If required, implementors can validate the embedCode.
+   */
+  public function validate() {
+  }
+
+  /**
+   * Before the file has been saved, implementors may do additional operations.
+   *
+   * @param object $file_obj
+   */
+  public function preSave(&$file_obj) {
+  }
+
+  /**
+   * Saves a file to the file_managed table (with file_save).
+   *
+   * @return StdClass
+   */
+  public function save() {
+    $file_obj = $this->getFileObject();
+    $this->preSave($file_obj);
+    file_save($file_obj);
+    $this->postSave($file_obj);
+    return $file_obj;
+  }
+
+  /**
+   * After the file has been saved, implementors may do additional operations.
+   *
+   * @param object $file_obj
+   */
+  public function postSave(&$file_obj) {
+  }
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaInternetFileHandler.inc b/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaInternetFileHandler.inc
new file mode 100644
index 00000000..c5b65cf5
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaInternetFileHandler.inc
@@ -0,0 +1,67 @@
+<?php
+
+/**
+ * @file
+ * Definition of MediaInternetFileHandler.
+ */
+
+/**
+ * A class for managing the addition of Internet files.
+ */
+class MediaInternetFileHandler extends MediaInternetBaseHandler {
+
+  public $fileObject;
+
+  public function preSave(&$file_obj) {
+    // Coppies the remote file locally.
+    $remote_uri = $file_obj->uri;
+    //@TODO: we should follow redirection here an save the final filename, not just the basename.
+    $local_filename = basename($remote_uri);
+    $local_filename = file_munge_filename($local_filename, variable_get('file_entity_default_allowed_extensions', 'jpg jpeg gif png txt doc docx xls xlsx pdf ppt pptx pps ppsx odt ods odp mp3 mov mp4 m4a m4v mpeg avi ogg oga ogv weba webp webm'), FALSE);
+    $local_uri = file_stream_wrapper_uri_normalize('temporary://' . $local_filename);
+    if (!@copy($remote_uri, $local_uri)) {
+      throw new Exception('Unable to add file ' . $remote_uri);
+      return;
+    }
+    // Make the current fileObject point to the local_uri, not the remote one.
+    $file_obj = file_uri_to_object($local_uri);
+  }
+
+  public function postSave(&$file_obj) {
+    $scheme = variable_get('file_default_scheme', 'public') . '://';
+    module_load_include('inc', 'file_entity', 'file_entity.pages');
+    $destination_uri = file_entity_upload_destination_uri(array());
+    $uri = file_stream_wrapper_uri_normalize($destination_uri . '/' . $file_obj->filename);
+    // Now to its new home.
+    $file_obj = file_move($file_obj, $uri, FILE_EXISTS_RENAME);
+  }
+
+  public function getFileObject() {
+    if (!$this->fileObject) {
+      $this->fileObject = file_uri_to_object($this->embedCode);
+    }
+    return $this->fileObject;
+  }
+
+  public function claim($embedCode) {
+    // Claim only valid URLs using a supported scheme.
+    if (!valid_url($embedCode, TRUE) || !in_array(file_uri_scheme($embedCode), variable_get('media_fromurl_supported_schemes', array('http', 'https', 'ftp', 'smb', 'ftps')))) {
+      return FALSE;
+    }
+
+    // This handler is intended for regular files, so don't claim URLs
+    // containing query strings or fragments.
+    if (preg_match('/[\?\#]/', $embedCode)) {
+      return FALSE;
+    }
+
+    // Since this handler copies the remote file to the local web server, do not
+    // claim a URL with an extension disallowed for media uploads.
+    $regex = '/\.(' . preg_replace('/ +/', '|', preg_quote(variable_get('file_entity_default_allowed_extensions', 'jpg jpeg gif png txt doc docx xls xlsx pdf ppt pptx pps ppsx odt ods odp mp3 mov mp4 m4a m4v mpeg avi ogg oga ogv weba webp webm'))) . ')$/i';
+    if (!preg_match($regex, basename($embedCode))) {
+      return FALSE;
+    }
+
+    return TRUE;
+  }
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaInternetNoHandlerException.inc b/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaInternetNoHandlerException.inc
new file mode 100644
index 00000000..5a199cc3
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaInternetNoHandlerException.inc
@@ -0,0 +1,13 @@
+<?php
+
+/**
+ * @file
+ * Definition of MediaInternetNoHandlerException.
+ */
+
+/**
+ * A custom exception class for handling embed code with no handler.
+ */
+class MediaInternetNoHandlerException extends Exception {
+
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaInternetValidationException.inc b/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaInternetValidationException.inc
new file mode 100644
index 00000000..36322b3e
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_internet/includes/MediaInternetValidationException.inc
@@ -0,0 +1,13 @@
+<?php
+
+/**
+ * @file
+ * Definition of MediaInternetValidationException.
+ */
+
+/**
+ * A custom exception class for handling file validation errors.
+ */
+class MediaInternetValidationException extends Exception {
+
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/media_internet.info b/drupal7/sites/all/modules/media/modules/media_internet/media_internet.info
index 71d2b65b..a01f8a2d 100644
--- a/drupal7/sites/all/modules/media/modules/media_internet/media_internet.info
+++ b/drupal7/sites/all/modules/media/modules/media_internet/media_internet.info
@@ -2,12 +2,19 @@ name = Media Internet Sources
 description = Provides an API for accessing media on various internet services
 package = Media
 core = 7.x
+
 dependencies[] = media
+
 files[] = includes/MediaBrowserInternet.inc
+files[] = includes/MediaInternetBaseHandler.inc
+files[] = includes/MediaInternetFileHandler.inc
+files[] = includes/MediaInternetNoHandlerException.inc
+files[] = includes/MediaInternetValidationException.inc
+files[] = tests/media_internet.test
 
-; Information added by drupal.org packaging script on 2013-10-25
-version = "7.x-2.0-alpha3"
+; Information added by Drupal.org packaging script on 2014-10-04
+version = "7.x-2.0-alpha4"
 core = "7.x"
 project = "media"
-datestamp = "1382744872"
+datestamp = "1412422430"
 
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/media_internet.install b/drupal7/sites/all/modules/media/modules/media_internet/media_internet.install
new file mode 100644
index 00000000..03264d41
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_internet/media_internet.install
@@ -0,0 +1,21 @@
+<?php
+
+/**
+ * @file
+ * Install, update and uninstall functions for the Media Internet module.
+ */
+
+/**
+ * Implements hook_uninstall().
+ */
+function media_internet_uninstall() {
+  // Remove variables.
+  variable_del('media_internet_fromurl_supported_schemes');
+}
+
+/**
+ * Rebuild the registry in order to accommodate moved classes.
+ */
+function media_internet_update_7000() {
+  registry_rebuild();
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/media_internet.module b/drupal7/sites/all/modules/media/modules/media_internet/media_internet.module
index 15418e6d..c60fbd80 100644
--- a/drupal7/sites/all/modules/media/modules/media_internet/media_internet.module
+++ b/drupal7/sites/all/modules/media/modules/media_internet/media_internet.module
@@ -19,10 +19,11 @@ function media_internet_menu() {
     'title' => 'Web',
     'description' => 'Add internet files to your media library.',
     'page callback' => 'drupal_get_form',
-    'page arguments' => array('media_internet_add'),
+    'page arguments' => array('media_internet_add_upload'),
     'access callback' => 'media_internet_access',
     'type' => MENU_LOCAL_TASK,
-    'file' => 'media_internet.pages.inc',
+    'file' => 'file_entity.pages.inc',
+    'file path' => drupal_get_path('module', 'file_entity'),
   );
 
   return $items;
@@ -47,6 +48,18 @@ function media_internet_permission() {
   );
 }
 
+/**
+ * Implements hook_theme().
+ */
+function media_internet_theme() {
+  return array(
+    // media_internet.pages.inc.
+    'media_internet_embed_help' => array(
+      'variables' => array('description' => NULL, 'supported_providers' => NULL),
+    ),
+  );
+}
+
 /**
  * Gets the list of providers.
  *
@@ -102,139 +115,204 @@ function media_internet_get_provider($embed_string) {
   throw new MediaInternetNoHandlerException(t('Unable to handle the provided embed string or URL.'));
 }
 
-class MediaInternetFileHandler extends MediaInternetBaseHandler {
+/**
+ * Returns HTML for help text based on supported internet media providers.
+ *
+ * @param $variables
+ *   An associative array containing:
+ *   - description: The normal description for this field, specified by the
+ *     user.
+ *   - supported_providers: A string of supported providers.
+ *
+ * @ingroup themeable
+ */
+function theme_media_internet_embed_help($variables) {
+  $description = $variables['description'];
+  $supported_providers = $variables['supported_providers'];
 
-  public $fileObject;
+  $descriptions = array();
 
-  public function preSave(&$file_obj) {
-    // Coppies the remote file locally.
-    $remote_uri = $file_obj->uri;
-    //@TODO: we should follow redirection here an save the final filename, not just the basename.
-    $local_filename = basename($remote_uri);
-    $local_filename = file_munge_filename($local_filename, variable_get('file_entity_default_allowed_extensions', 'jpg jpeg gif png txt doc docx xls xlsx pdf ppt pptx pps ppsx odt ods odp mp3 mov mp4 m4a m4v mpeg avi ogg oga ogv weba webp webm'), FALSE);
-    $local_uri = file_stream_wrapper_uri_normalize('temporary://' . $local_filename);
-    if (!@copy($remote_uri, $local_uri)) {
-      throw new Exception('Unable to add file ' . $remote_uri);
-      return;
-    }
-    // Make the current fileObject point to the local_uri, not the remote one.
-    $file_obj = file_uri_to_object($local_uri);
+  if (strlen($description)) {
+    $descriptions[] = $description;
   }
-
-  public function postSave(&$file_obj) {
-    $scheme = variable_get('file_default_scheme', 'public') . '://';
-    module_load_include('inc', 'file_entity', 'file_entity.pages');
-    $destination_uri = file_entity_upload_destination_uri(array());
-    $uri = file_stream_wrapper_uri_normalize($destination_uri . '/' . $file_obj->filename);
-    // Now to its new home.
-    $file_obj = file_move($file_obj, $uri, FILE_EXISTS_RENAME);
+  if (!empty($supported_providers)) {
+    $descriptions[] = t('Supported internet media providers: !providers.', array('!providers' => '<strong>' . $supported_providers . '</strong>'));
   }
 
-  public function getFileObject() {
-    if (!$this->fileObject) {
-      $this->fileObject = file_uri_to_object($this->embedCode);
-    }
-    return $this->fileObject;
+  return implode('<br />', $descriptions);
+}
+
+/**
+ * Implements hook_forms().
+ */
+function media_internet_forms($form_id, $args) {
+  $forms = array();
+
+  // Create a copy of the upload wizard form for internet media.
+  if ($form_id == 'media_internet_add_upload') {
+    $forms[$form_id] = array(
+      'callback' => 'file_entity_add_upload',
+    );
   }
 
-  public function claim($embedCode) {
-    // Claim only valid URLs using a supported scheme.
-    if (!valid_url($embedCode, TRUE) || !in_array(file_uri_scheme($embedCode), variable_get('media__fromurl_supported_schemes', array('http', 'https', 'ftp', 'smb', 'ftps')))) {
-      return FALSE;
+  return $forms;
+}
+
+/**
+ * Implements hook_form_FORM_ID_alter().
+ */
+function media_internet_form_file_entity_add_upload_alter(&$form, &$form_state, $form_id) {
+  $step = $form['#step'];
+  $options = $form['#options'];
+
+  // Swap the upload field for an embed field when on the first step of the web
+  // tab.
+  if ($form_id == 'media_internet_add_upload' && $step == 1) {
+    unset($form['upload']);
+
+    $form['embed_code'] = array(
+      '#type' => 'textfield',
+      '#title' => t('File URL'),
+      '#description' => t('Enter a URL to a file.'),
+      '#attributes' => array('class' => array('media-add-from-url')),
+      // There is no standard specifying a maximum length for a URL. Internet
+      // Explorer supports up to 2083 (http://support.microsoft.com/kb/208427)
+      // so we assume publicly available media URLs are within this limit.
+      '#maxlength' => 2083,
+      '#required' => TRUE,
+      '#default_value' => isset($form_state['storage']['embed_code']) ? $form_state['storage']['embed_code'] : NULL,
+    );
+
+    // Create an array to hold potential Internet media providers.
+    $providers = array();
+
+    // Determine if there are any visible providers.
+    foreach (media_internet_get_providers() as $key => $provider) {
+      if (empty($provider['hidden']) || $provider['hidden'] != TRUE) {
+        $providers[] = check_plain($provider['title']);
+      }
     }
 
-    // This handler is intended for regular files, so don't claim URLs
-    // containing query strings or fragments.
-    if (preg_match('/[\?\#]/', $embedCode)) {
-      return FALSE;
+    $form['#providers'] = $providers;
+
+    // Notify the user of any available providers.
+    if ($providers) {
+      // If any providers are enabled it is assumed that some kind of embed is supported.
+      $form['embed_code']['#title'] = t('File URL or media resource');
+      $form['embed_code']['#description'] = t('Enter a URL to a file or media resource. Many media providers also support identifying media via the embed code used to embed the media into external websites.');
+
+      $form['embed_code']['#description'] = theme('media_internet_embed_help', array('description' => $form['embed_code']['#description'], 'supported_providers' => implode(' ', $providers)));
     }
 
-    // Since this handler copies the remote file to the local web server, do not
-    // claim a URL with an extension disallowed for media uploads.
-    $regex = '/\.(' . preg_replace('/ +/', '|', preg_quote(variable_get('file_entity_default_allowed_extensions', 'jpg jpeg gif png txt doc docx xls xlsx pdf ppt pptx pps ppsx odt ods odp mp3 mov mp4 m4a m4v mpeg avi ogg oga ogv weba webp webm'))) . ')$/i';
-    if (!preg_match($regex, basename($embedCode))) {
-      return FALSE;
+    $form['#validators'] = array();
+
+    if (!empty($options['types'])) {
+      $form['#validators']['media_file_validate_types'] = array($options['types']);
     }
 
-    return TRUE;
+    // Add validation and submission handlers to the form and ensure that they
+    // run first.
+    array_unshift($form['#validate'], 'media_internet_add_validate');
+    array_unshift($form['#submit'], 'media_internet_add_submit');
   }
 }
 
-/*
- * Base MediaInternetBaseHandler class.
+/**
+ * Allow stream wrappers to have their chance at validation.
+ *
+ * Any module that implements hook_media_parse will have an
+ * opportunity to validate this.
  *
- * Classes extending this class manage the addition of Internet media. To
- * achieve this, the class should parse user-submitted embed code, claim it
- * when appropriate and save it as a managed file.
+ * @see media_parse_to_uri()
  */
-abstract class MediaInternetBaseHandler {
-
-  /**
-   * The constructor for the MediaInternetBaseHandler class. This method is also called
-   * from the classes that extend this class and override this method.
-   */
-  public function __construct($embedCode) {
-    $this->embedCode = $embedCode;
-  }
+function media_internet_add_validate($form, &$form_state) {
+  // Supporting providers can now claim this input. It might be a URL, but it
+  // might be an embed code as well.
+  $embed_code = $form_state['values']['embed_code'];
 
-  /**
-   * Determines if this handler should claim the item.
-   *
-   * @param string $embed_code
-   *   A string of user-submitted embed code.
-   *
-   * @return boolean
-   *   Pass TRUE to claim the item.
-   */
-  abstract public function claim($embed_code);
-
-  /**
-   * Returns a file object which can be used for validation.
-   *
-   * @return StdClass
-   */
-  abstract public function getFileObject();
-
-  /**
-   * If required, implementors can validate the embedCode.
-   */
-  public function validate() {
+  try {
+    $provider = media_internet_get_provider($embed_code);
+    $provider->validate();
   }
-
-  /**
-   * Before the file has been saved, implementors may do additional operations.
-   *
-   * @param object $file_obj
-   */
-  public function preSave(&$file_obj) {
+  catch (MediaInternetNoHandlerException $e) {
+    form_set_error('embed_code', $e->getMessage());
+    return;
   }
-
-  /**
-   * Saves a file to the file_managed table (with file_save).
-   *
-   * @return StdClass
-   */
-  public function save() {
-    $file_obj = $this->getFileObject();
-    $this->preSave($file_obj);
-    file_save($file_obj);
-    $this->postSave($file_obj);
-    return $file_obj;
+  catch (MediaInternetValidationException $e) {
+    form_set_error('embed_code', $e->getMessage());
+    return;
   }
 
-  /**
-   * After the file has been saved, implementors may do additional operations.
-   *
-   * @param object $file_obj
-   */
-  public function postSave(&$file_obj) {
+  $validators = $form['#validators'];
+  $file = $provider->getFileObject();
+
+  if ($validators) {
+    try {
+      $file = $provider->getFileObject();
+    }
+    catch (Exception $e) {
+      form_set_error('embed_code', $e->getMessage());
+      return;
+    }
+
+    // Check for errors. @see media_add_upload_validate calls file_save_upload().
+    // this code is ripped from file_save_upload because we just want the validation part.
+    // Call the validation functions specified by this function's caller.
+    $errors = file_validate($file, $validators);
+
+    if (!empty($errors)) {
+      $message = t('%url could not be added.', array('%url' => $embed_code));
+      if (count($errors) > 1) {
+        $message .= theme('item_list', array('items' => $errors));
+      }
+      else {
+        $message .= ' ' . array_pop($errors);
+      }
+      form_set_error('embed_code', $message);
+      return FALSE;
+    }
   }
-}
 
-class MediaInternetValidationException extends Exception {
+  // @TODO: Validate that if we have no $uri that this is a valid file to
+  // save. For instance, we may only be interested in images, and it would
+  // be helpful to let the user know they passed the HTML page containing
+  // the image accidentally. That would also save us from saving the file
+  // in the submit step.
+
+  // This is kinda a hack of the same.
 
+  // This should use the file_validate routines that the upload form users.
+  // We need to fix the media_parse_to_file routine to allow for a validation.
 }
 
-class MediaInternetNoHandlerException extends Exception {
+/**
+ * Upload a file from a URL.
+ *
+ * This will copy a file from a remote location and store it locally.
+ *
+ * @see media_parse_to_uri()
+ * @see media_parse_to_file()
+ */
+function media_internet_add_submit($form, &$form_state) {
+  $embed_code = $form_state['values']['embed_code'];
 
+  try {
+    // Save the remote file
+    $provider = media_internet_get_provider($embed_code);
+    // Providers decide if they need to save locally or somewhere else.
+    // This method returns a file object
+    $file = $provider->save();
+  }
+  catch (Exception $e) {
+    form_set_error('embed_code', $e->getMessage());
+    return;
+  }
+
+  if (!$file->fid) {
+    form_set_error('embed_code', t('The file %file could not be saved. An unknown error has occurred.', array('%file' => $embed_code)));
+    return;
+  }
+  else {
+    $form_state['storage']['upload'] = $file->fid;
+  }
 }
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/tests/includes/MediaInternetTestHandler.inc b/drupal7/sites/all/modules/media/modules/media_internet/tests/includes/MediaInternetTestHandler.inc
new file mode 100644
index 00000000..764279ca
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_internet/tests/includes/MediaInternetTestHandler.inc
@@ -0,0 +1,45 @@
+<?php
+
+/**
+ * @file
+ * Extends the MediaInternetBaseHandler class to handle videos from an imaginary example.com.
+ */
+
+/**
+ * Implementation of MediaInternetBaseHandler.
+ *
+ * @see hook_media_internet_providers().
+ */
+class MediaInternetTestHandler extends MediaInternetBaseHandler {
+  public function parse($embedCode) {
+    // http://example.com/video/*
+    $patterns = array(
+      '@example\.com/video/(\d+)@i',
+    );
+
+    foreach ($patterns as $pattern) {
+      preg_match($pattern, $embedCode, $matches);
+      if (isset($matches[1])) {
+        return file_stream_wrapper_uri_normalize('mediainternettest://video/' . $matches[1]);
+      }
+    }
+  }
+
+  public function claim($embedCode) {
+    if ($this->parse($embedCode)) {
+      return TRUE;
+    }
+  }
+
+  public function getFileObject() {
+    $uri = $this->parse($this->embedCode);
+    $file = file_uri_to_object($uri, TRUE);
+
+    // Override the default filename for testing purposes.
+    if (empty($file->fid)) {
+      $file->filename = 'Drupal';
+    }
+
+    return $file;
+  }
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/tests/includes/MediaInternetTestStreamWrapper.inc b/drupal7/sites/all/modules/media/modules/media_internet/tests/includes/MediaInternetTestStreamWrapper.inc
new file mode 100644
index 00000000..20253838
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_internet/tests/includes/MediaInternetTestStreamWrapper.inc
@@ -0,0 +1,24 @@
+<?php
+
+/**
+ *  @file
+ *  Extends the MediaReadOnlyStreamWrapper class to handle videos from an imaginary example.com.
+ */
+
+/**
+ *  Create an instance like this:
+ *  $media_internet_test = new MediaInternetTestStreamWrapper('mediainternettest://video/[video-code]');
+ */
+class MediaInternetTestStreamWrapper extends MediaReadOnlyStreamWrapper {
+  protected $base_url = 'http://example.com';
+
+  static function getMimeType($uri, $mapping = NULL) {
+    return 'video/mediainternettest';
+  }
+
+  function interpolateUrl() {
+    if ($parameters = $this->get_parameters()) {
+      return $this->base_url . '/' . $parameters['video'];
+    }
+  }
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet_test.info b/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet_test.info
new file mode 100644
index 00000000..193115db
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet_test.info
@@ -0,0 +1,15 @@
+name = Media Internet Test
+description = Provides hooks for testing Media Internet module functionality.
+package = Media
+core = 7.x
+hidden = TRUE
+
+files[] = includes/MediaInternetTestStreamWrapper.inc
+files[] = includes/MediaInternetTestHandler.inc
+
+; Information added by Drupal.org packaging script on 2014-10-04
+version = "7.x-2.0-alpha4"
+core = "7.x"
+project = "media"
+datestamp = "1412422430"
+
